#!/usr/bin/perl -w

#######################################################################################
#
# PLAYMESS.PL written by Kristof De Jaeger, Januari 2002
# Little perl-script for getting your games and generates menu for playing a xmess-game
#
# I use Figlet also to print ascii letters at top of menu (get it from rpmfind.net)
#
# INSTALL & USE
# -------------
#
# * chmod 755 playmess.pl to enable execution of the script
# * You can eventually rename the file to 'playmess' (or whatever you want)
#   and put it in a bin-dir so you don't have to type the path always
# * be sure you have a xmessrc-file so the program knows also where your roms are,
#   if you don't have one make one (xmess --showconfig > /home/whatever/.xmess/xmessrc)
#   and change the path to the roms if necessary
#
# HOW THIS SCRIPT WORKS
# ---------------------
# 
# It isn't easy to create a menu for xmess, because xmess emulates a lot of game-consoles
# so how do I go to work. Basically, YOU have to input YOUR games into the system.
# It is easier this way then reading the .zip or .bin or .sms or whatever
# extension, because there are a lot of them ...
# So, you just have to enter the 
#         - name of the game, 
#	  - the name of the rom, remember, you
#	    can always rename the filename (eg Sonic\ the\ hegdhog.sms -> sonic.sms), so it's
# 	    easier to type it in ! (I'm not going to check on blankspaces in the filename, that's 
# 	    too absurd in my opinion)
#	  - the cart : ex. : for segamaster system you have to type in sms ...  
#                      to know which abbreviation to use for which console, you can consult the readmes of mess
#                      or the list you can find also on my site (called messlist.txt)
#
# ---------------------
#
# Find more scripts on http://www.swentelomania.be/swentel
#
#

#######################################################################################
#
# config-vars
#
# The excact name of the xmess-binary (if necessary with path also)
$binmess = 'xmess';

# your homedir of .xmess with file which contains YOUR games (leave the 'ourlist' !) don't worry
# about the file, this is being generated if it doesn't exist
$ourgames = '/home/dave/.xmess/ourlist';

# your homedir of .xmess with file which contains the ignorelist (leave the 'ignorelist' !) don't worry
# about the file, this is being generated if it doesn't exist
$ignorelist = '/home/dave/.xmess/ignorelist';

# ASCII text output on top of screen :)
$ascii = 'Davedina Mess';

#######################################################################################
# Do not change anything below this, except if you know perl ..
# or want to laugh about my pathetic skills :)

# BEGIN OF SUBROUTINES

#######################################################################################
# start subroutine : get the games from ourlist and put them in menu

sub start(){

  # clean the screen
  system("clear");

  # check if ourlist exists, otherwise, just make one
  if  (!open(messlist,$ourgames)){
    system("touch $ourgames");
  }

  # if it exist, get the games and put them in array
  else{
	@legearray;
	@gamesarray = @legearray;
	while(<messlist>){
		push (@gamesarray,$_);
	}   
    # get last number of array
    $nr = $#gamesarray;
    $nr++;
  }
  close messlist;  

  # sort gamesarray
  @gamesarray = sort(@gamesarray);

  #system clear
  system("clear");

  # logo
  system ("figlet -f small $ascii -c");

  # now get every cell of array, split info and make menu

  $i = 1;
  @niks;
  @cart = @niks;
  @rom = @niks;
  @gameke = @niks;

  foreach $game(@gamesarray){
     @niks;
     @game = @niks;
     @game = split(/,/,$game);
     $varka = $i/2;
       if ($varka =~ /(.*)\.(.*)/){
         $first = $i;
         $menu1 = $game[0];
         chomp($game[0]);
         chomp($game[1]);
         chomp($game[2]);
	 push (@gameke,$game[0]);
	 push (@rom,$game[1]);
	 push (@cart,$game[2]);
         # if uneven number AND last one, write out
           if ($i == $nr){
             $second = '';
             $menu2 = '';
             write;
           }
       } 
       else{
         $second = $i;
         $menu2 = $game[0];
         chomp($game[0]);
         chomp($game[1]);
         chomp($game[2]);
	 push (@gameke,$game[0]);
	 push (@rom,$game[1]);
	 push (@cart,$game[2]);
         write;
       }	
    $i++;
  }


# menu output
format STDOUT =
@<<< @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< @<<< @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
$first, $menu1, $second, $menu2
.

print "\n";
print "Enter a number to play, 'ignore', 'add' or 0 to quit :\n";
print "Choose a game : ";
$messgame = <stdin>;

}

#######################################################################################
# check input from $messgame <stdin>:
# if game = 0, exit,

sub check(){
  chomp($messgame);
    if ($messgame eq "0"){
       print "Are you going to stop now already ?\n";
       exit(); 
    }
      elsif ($messgame eq "ignore"){
        ignore();
        start();  
        check();
      }
        elsif ($messgame eq "add"){
          add();
          start();
          check();
        }
    else{
      playgame();
    }
}

#######################################################################################
# add game subroutine

sub add(){

  system("clear");
  system ("figlet -f small $ascii -c");
  
  # typing stuff
  print "\nADD A NEW GAME (don't use comma's!)\n--------------\n";
  print "\nEnter name of the game : ";
  $newgame = <stdin>;
  chomp ($newgame);
  print "Enter name of the rom : ";
  $newrom = <stdin>;
  chomp ($newrom);
  print "If necessary, consult mess.txt to know which cart it is.\n";
  print "Enter name of the cart : ";
  $newcart = <stdin>;
  chomp ($newcart);
  $newone = $newgame.",".$newrom.",".$newcart;
  chomp($newone);
  system("echo $newone >> $ourgames");
}

#######################################################################################
# ignore game subroutine

sub ignore(){

  print "Enter the number of the game you want to ignore : ";
  $ignore = <stdin>;
  chomp($ignore);
  $ignore--;
  $ignore = $gameke[$ignore].",".$rom[$ignore].",".$cart[$ignore];
  chomp($ignore);
  # write to temp file
  open (ourlist,$ourgames);
    while (<ourlist>){
    chomp($_);
      if ($_ ne $ignore){
        system("echo $_ >> $ignorelist");
      } 
    }
    
  close ourlist; 
   
  # move temp file to ourlist
  system("mv -f $ignorelist $ourgames");

}

#######################################################################################
# startgame subroutine

sub playgame(){

  chomp ($messgame);
  $messgame--;

  system("$binmess $cart[$messgame] -cart $rom[$messgame]");
  start();
  check();
}

# END OF SUBROUTINES
#######################################################################################
# begin of program

start();
check();
